//
//  test12.cpp
//  Lecture3CPP
//
//  Created by presentations on 11/5/17.
//
//

#include <iostream>
using namespace std;

class Complex {
    public:
        Complex( double = 0.0, double = 0.0 );        // constructor
        Complex operator+( const Complex & ) const;   // addition
        Complex operator-( const Complex & ) const;   // subtraction
        void print() const;                           // output
    private:
        double real;                                  // real part
        double imaginary;                             // imaginary part
        // Complex number =  real + imaginary * sqrt(-1)
}; // end class Complex

Complex::Complex( double r, double i )  : real( r ), imaginary( i ) { }

Complex Complex::operator+( const Complex &operand2 ) const
{
    return Complex( real + operand2.real, imaginary + operand2.imaginary );
} // end operator+ function

Complex Complex::operator-( const Complex &operand2 ) const
{
    return Complex( real - operand2.real,imaginary - operand2.imaginary );
} // end operator- function


void Complex::print() const
{
    cout << '(' << real << ", " << imaginary << ')' << endl;
}


int main()
{
    Complex  x, y( 4.3, 8.2 ), z( 3.3, 1.1 );
    
    x = y + z;           //  equivalent to y.add(z)
    cout << "\n\nx = y + z:\n";
    x.print();
    
    x = y - z;
    cout << "\n\nx = y - z:\n";
    x.print();
    
    y = z;
    cout << "\n\ny = z:\n";
    y.print();
    
    return 0;
} // end function main
