//
//  test13.cpp
//  Lecture3CPP
//
//  Created by presentations on 11/5/17.
//
//

#include <iostream>
#include <iomanip>
using namespace std;

class PhoneNumber {
        friend ostream &operator<<( ostream&, const PhoneNumber & );
        friend istream &operator>>( istream&, PhoneNumber & );
    private:
        char areaCode[ 4 ];     // 3-digit area code and null
        char exchange[ 4 ];     // 3-digit exchange and null
        char line[ 5 ];         // 4-digit line and null
}; // end class PhoneNumber (interface)



// Overloaded stream-insertion operator (cannot be
// a member function if we would like to invoke it with cout <<somePhoneNumber;).
ostream &operator<<( ostream &output, const PhoneNumber &num )
{
    output << "(" << num.areaCode << ") " << num.exchange << "-" << num.line;
    return output;     // enables cout << a << b << c;
} // end operator<< function

istream &operator>>( istream &input, PhoneNumber &num )
{
    input.ignore();                              // skip (
    input >> setw(4) >> num.areaCode;            // input area code *
    input.ignore(2);                             // skip ) and space
    input >> setw(4) >> num.exchange;            // input exchange *
    input.ignore();                              // skip dash (-)
    input >> setw(5) >> num.line;                // input line *
    
    return input;                                  // enables cin >> a >> b >> c;
} // end operator>> function
// end class PhoneNumber (implementation)


//setw(n) restricts the number of characters read to one less than its argument.
//ignore( n , delimiter):  Skips n characters, or all characters up to delimiter.


int main()
{
    PhoneNumber phone; // create object phone
    
    cout << "Enter phone number in the form (123) 456-7890 :\n";
    
    // cin >> phone invokes operator>> function by
    // issuing the call operator>>( cin, phone ).
    cin >> phone;
    
    // cout << phone invokes operator<< function by
    // issuing the call operator<<( cout, phone ).
    cout << "The phone number entered was: " << phone << endl;
    return 0;
} // end function main
